$ifndef _SH1106_Def_
$define _SH1106_Def_
'***************************************************************************
'***************************************************************************
'***************************************************************************
'***************************************************************************
'***************************************************************************
'*  Name     : SH1106_Def_v0.x.inc                                              
'*  Version  : 0.2-20171008                                                         
'*           :     Initial version for SH1106 Controller                                                         
'*           :     Calling method via pre processor                                                         
'*           :     Not Used routines will not be compiled                                                         
'*  Version  : 0.25-20171012 SH1106_FlipDisplay() added
'*           :      SH1106_Init() clears graphic RAM before panel switch On                                                         
'*  Version  : 1.00-20171017 Not used variables deleted,                                                              
'*           :                                                              
'*           :                                                              
'*           :                                                              
'***************************************************************************
;
;   DEFINITIONS
;
;***************************************************************************
;-----------------------------------------------
;###############################################
;###############################################
;###############################################
;   VersionAdministration
Symbol  Def_Version      = 1        
Symbol  Def_VersionSub   = 00       
;###############################################
;###############################################
;###############################################
;-----------------------------------------------
;   Create System definitions
;---------------------------------------------------------------------------
Symbol  SH1106         = $3C << 1           ;I2C address SH1106 (=$3C) Bit0=R/W=1/0
    Symbol  DisplayWidth    = 128           ;# pixels
    Symbol  DisplayHeight   = 64            ;# pixels
    Symbol  ArraySize = ( DisplayWidth * DisplayHeight ) / 8       ;# pixels / 8 = # bytes    
#disable GLCD_CLS                           ;Clear Screen Proton disabled
;---------------------------------------------------------------------------
;   SH1106 declares
        Declare Warnings Off                ;Very ugly BUT: No Warning if the user has already used the declare
Declare Hbus_Bitrate    =   1000            ;Works on 1000 instead 400
        Declare Warnings On
        ;See page 12/13 of the datasheet SH1106
Symbol  ControlByteNext = %10000000         ;ContinuationBit set = Another Controlbyte follows databyte
Symbol  ControlByteLast = %10000000         ;ContinuationBit Clear = No Controlbyte follows only databyte(s)
Symbol  D_C_GDRAM       = %01000000         ;D/C# bit set = GDRAM byte(s) follows
Symbol  D_C_Command     = %00000000         ;D/C# bit Clear = Command byte(s) follows
    ;Make combi for ControlByte
Symbol  NextCB_Command  = %10000000         ;ControlByteNext | D_C_Command
Symbol  LastCB_Command  = %00000000         ;ControlByteLast | D_C_Command
Symbol  NextCB_GDRAM    = %11000000         ;ControlByteNext | D_C_GDRAM
Symbol  LastCB_GDRAM    = %01000000         ;ControlByteLast | D_C_GDRAM
;---------------------------------------------------------------------------
;   Create variables
;---------------------------------------------------------------------------
;   Videobuffer in PIC memory
;   The displays are 64x128 the controller is 64x132
;   DISPLAY=128 cols x 64 rows= 8192bits= 1024Bytes
;   SH1106 GDRAM= 132 cols x 8bit(=1Byte)= Page Total 132 cols x 8 pages
;   SH1106 Page= 132 bytes = 132*8=1056pixels
;   SH1106 Minimum Write = 1 Byte = 8 pixels. So there is no "real pixel" cursor position
;   We write a page starting at position 2 ending at position 129 leaving 0-1 and 130-131 unfilled 
Dim     bVideoMem[ArraySize] As Byte    ;videobuffer 128x64 pixels=bits  
Dim     wElement#No         As Word            ;Array element in VideoMem
Dim     FSR0                As FSR0L.Word       ;Addressing of variable
;------------------------------------------------------------------------------
;   SH1106
Dim     SH1106_bCommand     As Byte     ;Command byte
Dim     SH1106_bContrast    As Byte     ;Contrast value
Dim     SH1106_xFlipped     As Byte     ;Is display Flipped Yes=1 No=0
;-------------------------------------------------------------------------------
;   SH1106_Plot
Dim     SH1106_bPlotX       As Byte     ;SH1106_Plot X
Dim     SH1106_bPlotY       As Byte     ;SH1106_Plot Y
Dim     SH1106_xPlotColor   As Bit      ;SH1106_Plot Color 1=White 0=Black
Dim     SH1106_bPlotByte    As Byte     ;SH1106_Plot Byte uit VideoMem
Dim     SH1106_bPlotBitNum  As Byte     ;SH1106_Plot Bit positie in VideoMem Byte
;-------------------------------------------------------------------------------
;   Temp variable
Dim     SH1106_wTemp        As Word
Dim     SH1106_bCol         As Byte
Dim     SH1106_bPage        As Byte
;***************************************************************************
;   END SH1106_Def.Inc
;***************************************************************************
$endif
;===========================================================================

