$ifndef _SH1106_Sub_
$define _SH1106_Sub_
'***************************************************************************
'***************************************************************************
'***************************************************************************
'***************************************************************************
'***************************************************************************
'*  Name     : SH1106_Sub_v0.x.inc                                              
'*  Founding Fathers : Gabi, VaGyver, Ray Ellam, Les Johnson                
'*  Version  : 0.2-20171008                                                         
'*           :     Initial version for SH1106 Controller                                                         
'*           :     Calling method via pre processor                                                         
'*           :     Not Used routines will not be compiled                                                         
'*  Version  : 0.25-20171012 SH1106_FlipDisplay() added
'*           :      SH1106_Init() clears graphic RAM before panel switch On                                                         
'*  Version  : 1.00-20171017 Not used variables deleted,                                                              
'*           :                                                              
'*           :                                                              
'*           :                                                              
'***************************************************************************
GoTo OverSH1106_Sub
;-----------------------------------------------
;###############################################
;###############################################
;###############################################
;   VersionAdministration
Symbol  Sub_Version      = 1        
Symbol  Sub_VersionSub   = 00       
;###############################################
;###############################################
;###############################################
;
;   Subroutines
;
;***************************************************************************
;   Point Cls in the right direction
;----------------------------------------------------------------------------
Asm
GLCD@CLS
    GoTo SH1106_ClearScreenSub
EndAsm
;----------------------------------------------------------------------------
;   SH1106_Command(P1)
;Writes Controlbyte and SH1106_bCommand to the SH1106
;Input : SH1106_bCommand
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_Command(P1)         '
        SH1106_bCommand = P1       '
        GoSub SH1106_CommandSub
        
SH1106_CommandSub:
    ;Send LastControlByte, bCommand to SH1106 device
    HBusOut SH1106, [LastCB_Command, SH1106_bCommand]
Return
;----------------------------------------------------------------------------
;   SH1106_Init
;Init the SH1106 display Controller
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_Init()         ' 
        GoSub SH1106_InitSub
        
SH1106_InitSub:
    ;Init the SH1106 device
DelayMS 500                     'Wait a moment

    ;Sometimes the SH1106 has cold start problems, Wake him up
HBStart
    HBusOut SH1106
HBStop
DelayMS 10
                            ;The SH1106 PowerOnReset values are not set again
HBStart                     ;Send a Start condition to the I2C bus
    HBusOut SH1106         ;Slave Adress 
    
    HBusOut NextCB_Command  ;Volgende byte=Command daarna ControlByte
    HBusOut $AE             ;turn off oled panel
    HBusOut NextCB_Command  ;
    HBusOut $A1             ;Segment Remap rotate right=A0 default
    HBusOut NextCB_Command  ;
    HBusOut $C8             ;COM output scan direction Normal=C0 default
    SH1106_xFlipped = 1     ;Administrate Flipped Display
    HBusOut NextCB_Command  ;
    HBusOut $DA             ;COM pads mode
    HBusOut NextCB_Command  ;
    HBusOut $12             ;Alternative
    HBusOut NextCB_Command  ;
    HBusOut $D3             ;Display Offset
    HBusOut NextCB_Command  ;
    HBusOut $00             ;No Offset
    HBusOut NextCB_Command  ;
    HBusOut $A8             ;Multiplex Ratio
    HBusOut NextCB_Command  ;
    HBusOut $3F             ;64
    HBusOut NextCB_Command  ;
    HBusOut $D5             ;Display Divide/Osc Freq
    HBusOut NextCB_Command  ;
    HBusOut $F0             ;Divide=5 default, Osc Freq=0
    HBusOut NextCB_Command  ;
    HBusOut $DB             ;VCOM level
    HBusOut NextCB_Command  ;
    HBusOut $35             ;0.770
    HBusOut NextCB_Command  ;
    HBusOut $81             ;Set contrast
    HBusOut NextCB_Command  ;
    HBusOut $FF             ;max contrast
    HBusOut NextCB_Command  ;
    HBusOut $30             ;Vpp level = 7.4V
    HBusOut NextCB_Command  ;
    HBusOut $AD             ;DC-DC On/Off
    HBusOut NextCB_Command  ;
    HBusOut $8B             ;On when Display On
    HBusOut LastCB_Command  ;Volgende Byte=Command daarna GEEN ControlByte meer
    HBusOut $40             ;Set Display Startline=0
HBStop
GoSub SH1106_Blank           ;Blank al the graphic ram in the SH1106
SH1106_Command($Af)         ;Turn on OLED panel

DelayMS 150                 ;wait for 150ms (page 31 datasheet)

    ;Zet de col en page positionering op 2,0
SH1106_GotoStartPos:
HBStart
    HBusOut SH1106          ;Slave address
        ;Set Display StartLine = 0 (= Com0 output)
    HBusOut NextCB_Command
    HBusOut $40
        ;Col address = 2 (0 And 1 NOT USED - 132 to 128 mapping)
        ;Set Lower Column Address: (00H - 0FH)
    HBusOut NextCB_Command
        ;Set Colomn value = 2 
    HBusOut $02               ;four lower bits of Colomnnumber
        ;Set Higher Column Address: (10H - 1FH)
    HBusOut NextCB_Command
    HBusOut %00010000       ;D4=set=4 higher bits of colomnnumber
        ;Page Address
        ;Set Page Address: (B0H - B7H)
    HBusOut LastCB_Command  ;Volgende Byte=Command daarna GEEN ControlByte meer
    HBusOut $B0             ;$B0=Page 0
HBStop    
Return
;
;Fill the total SH1106 graphic memory with $00
;This is part of SH1106_Init()
;The DisplayPanel is still OFF
SH1106_Blank:
Clear SH1106_wTemp
For SH1106_bPage = 0 To 7           ;8 Pages to send
    HBStart
        HBusOut SH1106              ;Address of SH1106
        HBusOut NextCB_Command
        HBusOut $00                 ;four lower bits of Colomnnumber
        HBusOut NextCB_Command
        HBusOut %00010000           ;D4=set=4 higher bits of colomnnumber
        HBusOut NextCB_Command
        HBusOut (%10110000 | SH1106_bpage )   ;Page Address  = $B0-$B7
        HBusOut LastCB_GDRAM        ;Send ControlByte with No more ControlBytes and data is GDRAM
        Clear SH1106_bCol           ;Clear col counter
        Repeat                      ;stream one full page (132!) to the SH1106    
            HBusOut bVideoMem[SH1106_wTemp]
            Inc SH1106_wTemp
            Inc SH1106_bCol
        Until SH1106_bCol = 132
    HBStop
Next
Return
;----------------------------------------------------------------------------
;   [SH1106_]Contrast(P1)
;Set the contrast value of the display 
;Input : SH1106_bContrast
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_Contrast(P1)     '
        SH1106_bContrast = P1   '
        _SH1106_ContrastSub
$define Contrast(P1)     '
        SH1106_bContrast = P1   '
        _SH1106_ContrastSub

_SH1106_ContrastSub Macro-
    GoSub SH1106_ContrastSub
Endm

#ifMacro- _SH1106_ContrastSub          ;If not used no code        
SH1106_ContrastSub:
    SH1106_Command($81)                ;Send Contrast Command
    SH1106_Command(SH1106_bContrast)  ;Send Contrast value
    Return
#endIfMacro-
;----------------------------------------------------------------------------
;   [SH1106_]DisplayOn()
;Switch the display ON 
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_DisplayOn()     '
        _SH1106_DisplayOnSub
$define DisplayOn()     '
        _SH1106_DisplayOnSub

_SH1106_DisplayOnSub Macro-
    GoSub SH1106_DisplayOnSub
Endm

#ifMacro- _SH1106_DisplayOnSub          ;If not used no code        
SH1106_DisplayOnSub:
    SH1106_Command($AF)                ;Send Display ON Command
    Return
#endIfMacro-
;----------------------------------------------------------------------------
;   [SH1106_]DisplayOff()
;Switch the display Off 
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_DisplayOff()     '
        _SH1106_DisplayOffSub
$define DisplayOff()     '
        _SH1106_DisplayOffSub

_SH1106_DisplayOffSub Macro-
    GoSub SH1106_DisplayOffSub
Endm

#ifMacro- _SH1106_DisplayOffSub          ;If not used no code        
SH1106_DisplayOffSub:
    SH1106_Command($AE)                ;Send Display Off Command
    Return
#endIfMacro-
;----------------------------------------------------------------------------
;   [SH1106_]DisplayInverse()
;Switch the display Inverse 
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_DisplayInverse()     '
        _SH1106_DisplayInverseSub
$define DisplayInverse()     '
        _SH1106_DisplayInverseSub

_SH1106_DisplayInverseSub Macro-
    GoSub SH1106_DisplayInverseSub
Endm

#ifMacro- _SH1106_DisplayInverseSub          ;If not used no code        
SH1106_DisplayInverseSub:
    SH1106_Command($A7)                ;Send Display Inverse Command
    Return
#endIfMacro-
;----------------------------------------------------------------------------
;   [SH1106_]DisplayNormal()
;Switch the display Normal 
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_DisplayNormal()     '
        _SH1106_DisplayNormalSub
$define DisplayNormal()     '
        _SH1106_DisplayNormalSub

_SH1106_DisplayNormalSub Macro-
    GoSub SH1106_DisplayNormalSub
Endm

#ifMacro- _SH1106_DisplayNormalSub          ;If not used no code        
SH1106_DisplayNormalSub:
    SH1106_Command($A6)                ;Send Display Normal Command
    Return
#endIfMacro-
;----------------------------------------------------------------------------
;   [SH1106_]FlipDisplay()
;Flip the display upside down and back
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_FlipDisplay()     '
        _SH1106_FlipDisplaySub
$define FlipDisplay()     '
        _SH1106_FlipDisplaySub

_SH1106_FlipDisplaySub Macro-
    GoSub SH1106_FlipDisplaySub
Endm

#ifMacro- _SH1106_FlipDisplaySub          ;If not used no code        
SH1106_FlipDisplaySub:
        ;Flip display normal if Flipped 
    If SH1106_xFlipped = 1 Then
        SH1106_Command($A0)                ;Normal Display in X-direction
        SH1106_Command($C0)                ;Normal Display in y-direction
        SH1106_xFlipped = 0
    Else
        SH1106_Command($A1)                ;Flipped Display in X-direction
        SH1106_Command($C8)                ;Flipped Display in y-direction
        SH1106_xFlipped = 1
    EndIf    
        ;$A1/A0 Set Segment Remap (Col0->Seg127/Seg0). Effects subsequent writes 
        ;So rewrite total display
    GoSub SH1106_RefreshDisplaySub
    Return
#endIfMacro-
;----------------------------------------------------------------------------
;   SH1106_ClearVideoMem()
;Clear the VideoMem array 
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_ClearVideoMem()     '
        _SH1106_ClearVideoMemSub
$define ClearVideoMem()     '
        _SH1106_ClearVideoMemSub
        
_SH1106_ClearVideoMemSub Macro-
    GoSub SH1106_ClearVideoMemSub
Endm

#ifMacro- _SH1106_ClearVideoMemSub      ;If not used, don't compile        
SH1106_ClearVideoMemSub:
    Clear bVideoMem
    Return
#endIfMacro-
;----------------------------------------------------------------------------
;   SH1106_RefreshDisplay()
;Send the VideoMem to the SH1106 Controller/Display
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_RefreshDisplay()     '
        GoSub SH1106_RefreshDisplaySub
$define RefreshDisplay()     '
        GoSub SH1106_RefreshDisplaySub

SH1106_RefreshDisplaySub:              ;Always used no conditional compiling
    ;Send the bVideoMem array to the SH1106
    ;It is a SH1106 Controller so every page has to be addressed
    ;The Col pointer is autoIncrement but PagePointer not and must be set 
    ;everytime time there is a page change
    ;So we stream 8 times one page starting with col + page address setting
    ;Attention The connected display is normaly 128 wide and the controller 132
    ;so every page starts with two bytes blanks (not used) and end with two (not used). 
Clear SH1106_wTemp
For SH1106_bPage = 0 To 7     ;8 Pages to send
    HBStart
        HBusOut SH1106        ;Address of SH1106
            ;Col address = 2 Col 0-1 isn't used 
            ;Set Lower Column Address: (00H - 0FH)
        HBusOut NextCB_Command
        HBusOut $02           ;four lower bits of Colomnnumber
            ;Set Higher Column Address: (10H - 1FH)
        HBusOut NextCB_Command
        HBusOut %00010000   ;D4=set=4 higher bits of colomnnumber
            ;Page Address
            ;Set Page Address: (B0H - B7H)
        HBusOut NextCB_Command
        HBusOut (%10110000 | SH1106_bpage )
            ;Send ControlByte with No more ControlBytes and data is GDRAM
        HBusOut LastCB_GDRAM
        Clear SH1106_bCol               ;Clear col counter
            ;The SH1106 pointer is  positioned at x=2 , y=page
        Repeat                      ;stream one page to the SH1106    
            HBusOut bVideoMem[SH1106_wTemp]
            Inc SH1106_wTemp
            Inc SH1106_bCol
        Until SH1106_bCol = displaywidth
            ;We don't fill column 130 and 131
    HBStop
Next
Return
;----------------------------------------------------------------------------
;   SH1106_ClearScreen()  = Cls
;Clear het SH1106 display and the VideoMem 
;Input : 
;Output:
;Notes :
;----------------------------------------------------------------------------
$define SH1106_ClearScreen()     '
        _SH1106_ClearScreenSub

SH1106_ClearScreenSub:
    SH1106_ClearVideoMem()              ;Clear videomem
    SH1106_RefreshDisplay()             ;Display cleared mem
    GoSub SH1106_GotoStartPos           ;position hardware cursor at HomePosition
    Return
;----------------------------------------------------------------------------
;   Graphic_Plot(P1,P2,P3)
;****Gate to SH1106 for graphic routines**** Plot a pixel in VideoMem 
;This routine is the ONLY entrance to the SH1106 except some special direct SH1106Commands
;like SH1106_Contrast, SH1106_Inverse and Normal, SH1106_DisplayOff and DisplayOn 
;Input : bPlotX, bPlotY, bPlotColor
;Output:
;Notes : Calling routine uses Word variable, SH1106 is max. 132 x 64 so byte size
;----------------------------------------------------------------------------
$define Graphic_Plot(P1, P2, P3)    '
        SH1106_bPlotX = P1.Byte0    '
        SH1106_bPlotY = P2.Byte0    '
        SH1106_xPlotColor = P3.0    '
        GoSub SH1106_PlotSub

SH1106_PlotSub:
$ifdef SH1106_DisplayHalf
        ;Half display only use the uneven bits of the SH1106 VideoMemory in the y-axis
        ;So Ynew = (Y * 2) + 1
    SH1106_bPlotY = (SH1106_bPlotY << 1) + 1
$endif
    ;Within the Display bounderies? No then no action=return
If SH1106_bPlotX >= DisplayWidth Then Return
If SH1106_bPlotY >= DisplayHeight Then Return
    ;Get the VideoMem byte and bitposition in the byte of the pointed point
    ;8 yBits in one byte, so Y/8 Pages * displaywidth + xPixel = VideoMem position
wElement#No = ( SH1106_bPlotY >> 3 ) * DisplayWidth + SH1106_bPlotX
    ;Bit position of coordinate in VideoByte = mod 8 bitposition
SH1106_bPlotBitNum = SH1106_bPlotY & %00000111 
    ;Point FSRO to array VideoMem and add offset
FSR0 = AddressOf (bVideoMem) + wElement#No
    ;Get VideoMem byte
SH1106_bPlotByte = INDF0                                  
    ;Put bColor in Byte
LoadBit SH1106_bPlotByte, SH1106_bPlotBitNum, SH1106_xPlotColor
    ;Put Byte back in VideoMem
    ;for safety fill FSR0 again
FSR0 = AddressOf (bVideoMem) + wElement#No
INDF0 = SH1106_bPlotByte                                  ;Put VideoMem byte
Return
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
;----------------------------------------------------------------------------
OverSH1106_Sub:
    ;Yes sneaky Init SH1106 automatically
SH1106_Init()
;***************************************************************************
;   END SH1106_Sub.Inc 
;***************************************************************************
$endif

